package hexamap;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.rmi.*;

public class Board extends JPanel implements KeyListener {

  private RemoteMap map;
  private Image img;
  private int id;
  private Config cfg;

  public Board(RemoteMap map,int id) throws Exception {
    super();
    this.map = map;
    this.id = id;
    cfg = map.getConfig();
    enableEvents(-1);
  }

  public void paint(Graphics g) {
    if (img==null) img = createImage(getSize().width,getSize().height);
    Graphics ig = img.getGraphics();
    ig.clearRect(0,0,getSize().width,getSize().height);
    try {
        DefaultMapPainter.paintMap(map,cfg,ig,50,50,id);
    } catch(RemoteException re) {}
    ig.setColor(Xagone.cols[id]);
    ig.fillOval(10,10,16,16);
    g.clearRect(0,0,getSize().width,getSize().height);
    try { g.drawImage(img,map.getDx(),map.getDy(),null); } catch(Exception e) {}
  }

  public Dimension getPreferredSize() {
    int dx = (int)(Math.sqrt(3.0)*(cfg.size/2));
    return new Dimension(cfg.width*(2*dx)+100-dx,((1+(cfg.height/2))*dx*2)+((cfg.height/2)*cfg.size)+100);
  }

  public void processMouseEvent(MouseEvent e) {
    if (e.getID()==MouseEvent.MOUSE_PRESSED) {
      try {
          map.clickAt(e.getX(),e.getY(),id);
      } catch(RemoteException re) {}
    }
  }

  public void processMouseMotionEvent(MouseEvent e) {
    try {
        map.moveOn(e.getX(),e.getY(),id);
    } catch(RemoteException re) {}
  }

  public void keyPressed(KeyEvent e) {
  }

  public void keyReleased(KeyEvent e) {
  }

  public void keyTyped(KeyEvent e) {
    try {
        map.doKey((""+e.getKeyChar()).toLowerCase().charAt(0),id);
    } catch(RemoteException re) {}
  }
}
