package hexamap;

import java.util.*;

// Non-human player

public class Computer {

  private int id;
  private XaMap map;
  private Config cfg;

  private Xagone oldgun = null;
  private Xagone oldtgt = null;
  private Vector building = new Vector();
  private int prio, cntprio;
  private Vector alliance = new Vector();

  public Computer(XaMap map,int id,Config cfg) {
    this.id = id;
    this.map = map;
    this.cfg = cfg;
    this.prio = 0;
    this.cntprio = 1+(int)(Math.random()*5);
  }

  public int getID() {
    return id;
  }

  public void addFriend(int friendId) {
    alliance.addElement(new Integer(friendId));
  }

  private boolean inAlliance(int otherId) {
    return (otherId==id) || alliance.contains(new Integer(otherId));
  }

  public void playRound() {
    Vector xs = new Vector(cfg.height*cfg.width);
    for (int i = 0; i < cfg.height; i++) {
        for (int j = 0; j < cfg.width-(i%2); j++) xs.addElement(map.getHexagone(j,i));
    }
    int size = xs.size();
    int pwr = cfg.getGunPower();
    int pass = 0;

    if (prio>0) {
       cntprio--;
       if (cntprio==0) prio=0;
    }

    // Melt xagone order
    for (int i=0;i<size*2;i++) {
        Object o = xs.elementAt((int)(Math.random()*size));
	      xs.removeElement(o);
	      xs.addElement(o);
    }
 
    int minNb = cfg.getMinNb();

    // Rescue
    int sm = 4*pwr;
    Xagone lxg = null;
    for (int i = 0; i < size; i++) {
        Xagone xg = (Xagone)xs.elementAt(i),xe,xne,xse,xw,xnw,xsw;
        if ((xg.getID()!=id)||(xg.getBase()<cfg.nbBuild)||(xg.getNb()>sm)) {
           if (i+1<size||lxg==null||(Math.random()<0.3)) continue;
           else xg = lxg;
        } else {
           if (!xg.isUnderAttack()) {
              lxg = xg;
              if (i+1<size) continue;
           }
        }
        // Find help
        if (((xe=(Xagone)xg.getE())!=null)   && (xe.getID()==id)  && (xe.getBase()==cfg.nbBuild)  && (!xe.goW())   && (xe.getNb()>sm))  { xe.linkW (true);  return; }
        if (((xne=(Xagone)xg.getNE())!=null) && (xne.getID()==id) && (xne.getBase()==cfg.nbBuild) && (!xne.goSW()) && (xne.getNb()>sm)) { xne.linkSW(true); return; }
        if (((xse=(Xagone)xg.getSE())!=null) && (xse.getID()==id) && (xse.getBase()==cfg.nbBuild) && (!xse.goNW()) && (xse.getNb()>sm)) { xse.linkNW(true); return; }
        if (((xw=(Xagone)xg.getW())!=null)   && (xw.getID()==id)  && (xw.getBase()==cfg.nbBuild)  && (!xw.goE())   && (xw.getNb()>sm))  { xw.linkE (true);  return; }
        if (((xnw=(Xagone)xg.getNW())!=null) && (xnw.getID()==id) && (xnw.getBase()==cfg.nbBuild) && (!xnw.goSE()) && (xnw.getNb()>sm)) { xnw.linkSE(true); return; }
        if (((xsw=(Xagone)xg.getSW())!=null) && (xsw.getID()==id) && (xsw.getBase()==cfg.nbBuild) && (!xsw.goNE()) && (xsw.getNb()>sm)) { xsw.linkNE(true); return; }
        // No help : remove link
        if (xg.goE()  && ((xe.getID() !=id) || (xe.getBase() ==cfg.nbBuild))) { xg.linkE (false); return; }
        if (xg.goNE() && ((xne.getID()!=id) || (xne.getBase()==cfg.nbBuild))) { xg.linkNE(false); return; }
        if (xg.goSE() && ((xse.getID()!=id) || (xse.getBase()==cfg.nbBuild))) { xg.linkSE(false); return; }
        if (xg.goW()  && ((xw.getID() !=id) || (xw.getBase() ==cfg.nbBuild))) { xg.linkW (false); return; }
        if (xg.goNW() && ((xnw.getID()!=id) || (xnw.getBase()==cfg.nbBuild))) { xg.linkNW(false); return; }
        if (xg.goSW() && ((xsw.getID()!=id) || (xsw.getBase()==cfg.nbBuild))) { xg.linkSW(false); return; }
    }

    if ((prio==1)||(prio<1&&Math.random()<0.5)) {
       int nb = 0;
       if (cfg.maxBases>0) {
          for (int i=0;i<Xagone.bases.size();i++)
              if (((Xagone)Xagone.bases.elementAt(i)).getID()==id) nb++;
       }
       if (cfg.maxBases==0||nb<cfg.maxBases) {
          // Bases construction in progress
          for (int i = 0; i < building.size(); i++) {
              Xagone xg = (Xagone)building.elementAt(i);
              if (xg.getID()!=id) {
                 building.removeElement(xg);
                 i--;
                 continue;
              }
              if ((xg.getNb()<minNb)||(xg.getBase()==cfg.nbBuild)) continue;
              xg.doKey('b',id);
              if (xg.getBase()==cfg.nbBuild) building.removeElement(xg);
              return;
          }
          // New bases construction
          for (int i = 0; i < size; i++) {
              Xagone xg = (Xagone)xs.elementAt(i);
              if ((xg.getID()!=id)||(xg.getNb()<minNb)||(xg.getBase()==cfg.nbBuild)) continue;
              xg.doKey('b',id);
              building.addElement(xg);
              return;
          }
       }
       pass++;
    }

    if ((prio==2)||(prio<2&&Math.random()<0.7)) {
       // Elevation
       Xagone min = null;
       int alt = 0;
       for (int i = 0; i < size; i++) {
           Xagone xg = (Xagone)xs.elementAt(i);
           if ((xg.getID()!=id)||(xg.getNb()<minNb)||(xg.getBase()<cfg.nbBuild)) continue;
           Hexagone[] all = xg.getAll();
           int m = -1;
           for (int j=0;j<6;j++) {
               Xagone xx = (Xagone)all[j];
               if (xx==null||xx.getAlt()<m) continue;
               m=xx.getAlt();
           }
           if (min==null||(m>=0&&(m-xg.getAlt()>alt))) {
              min = xg;
              alt = m-xg.getAlt();
           }
       }
       if (min!=null&&min.getAlt()<15) {
          min.doKey('u',id);
          return;
       }
       pass++;
    }

    if ((prio==3)||(prio<3&&Math.random()<0.5)) {
       // Ground Attack
       Vector v = null;
       Vector w = null;
       Xagone mx = null;
       for (int i = 0; i < size; i++) {
           Xagone xg = (Xagone)xs.elementAt(i);
           if ((xg.getID()==id&&xg.getNb()>minNb)||(xg.getAlt()<0)||inAlliance(xg.getID())) continue;
           Hexagone[] all = xg.getAll();
           v = new Vector();
           int nb = 0;
           for (int k=0;k<6;k++) {
               Xagone xx = (Xagone)all[k];
               if ((xx!=null)&&(xx.getID()==id)&&((xx.getBase()==0)||(xx.getBase()==cfg.nbBuild))) {
                  v.addElement(xx);
                  nb += xx.getNb();
               }
           }
           if ((v.size()==0)||((w!=null)&&(w.size()>=v.size()))||(nb<(minNb*v.size()))) continue;
           w = v;
           mx = xg;
       }

       if (w!=null) {
          for (int k=0;k<w.size();k++) {
              Xagone xg = (Xagone)w.elementAt(k);
              Xagone xx = null;
              if (xg.goW()&& ((xx=(Xagone)xg.getW())!=mx) ) xg.linkW(false);
              if (xg.goNW()&&((xx=(Xagone)xg.getNW())!=mx)) xg.linkNW(false);
              if (xg.goSW()&&((xx=(Xagone)xg.getSW())!=mx)) xg.linkSW(false);
              if (xg.goE()&& ((xx=(Xagone)xg.getE())!=mx) ) xg.linkE(false);
              if (xg.goNE()&&((xx=(Xagone)xg.getNE())!=mx)) xg.linkNE(false);
              if (xg.goSE()&&((xx=(Xagone)xg.getSE())!=mx)) xg.linkSE(false);
              xg.link(mx);
          }
          return;
       }
       pass++;
    }

    if ((prio==4)||(prio<4&&Math.random()<0.7)) {
       // Remove links to water and alliance
       for (int i = 0; i < size; i++) {
           Xagone xg = (Xagone)xs.elementAt(i),xx;
           if (xg.getID()!=id) continue;
           if (xg.goE()&& ((xx=(Xagone)xg.getE()).getAlt()  < 0 || (xx.getID()!=id&&inAlliance(xx.getID())))) { xg.linkE(false);  return; }
           if (xg.goNE()&&((xx=(Xagone)xg.getNE()).getAlt() < 0 || (xx.getID()!=id&&inAlliance(xx.getID())))) { xg.linkNE(false); return; }
           if (xg.goSE()&&((xx=(Xagone)xg.getSE()).getAlt() < 0 || (xx.getID()!=id&&inAlliance(xx.getID())))) { xg.linkSE(false); return; }
           if (xg.goW()&& ((xx=(Xagone)xg.getW()).getAlt()  < 0 || (xx.getID()!=id&&inAlliance(xx.getID())))) { xg.linkW(false);  return; }
           if (xg.goNW()&&((xx=(Xagone)xg.getNW()).getAlt() < 0 || (xx.getID()!=id&&inAlliance(xx.getID())))) { xg.linkNW(false); return; }
           if (xg.goSW()&&((xx=(Xagone)xg.getSW()).getAlt() < 0 || (xx.getID()!=id&&inAlliance(xx.getID())))) { xg.linkSW(false); return; }
       }
       pass++;
    }

    if ((prio==5)||(prio<5&&Math.random()<0.3)) {
       // Fill water
       Vector v = new Vector();
       for (int i = 0; i < size; i++) {
           Xagone xg = (Xagone)xs.elementAt(i);
           if ((xg.getID()==id)||(xg.getAlt()>=0)) continue;
           Hexagone[] all = xg.getAll();
           v.removeAllElements();
           int nb = 0;
           for (int k=0;k<6;k++) {
               if ((all[k]!=null)&&(((Xagone)all[k]).getID()==id)) {
                  v.addElement(all[k]);
                  nb += ((Xagone)all[k]).getNb();
               }
           }
           if ((v.size()<2)||(nb<2*minNb)) continue;
           xg.doKey('f',id);
           return;
       }
       pass++;
    }

    if ((prio==6)||(pass>1)||(prio<6&&Math.random()<0.3)) {
       // Paras and guns
       Xagone maxgun = (oldgun!=null&&(oldgun.getID()==id)&&(oldtgt.getID()>0)&&(!inAlliance(oldtgt.getID())))?oldgun:null;
       Xagone maxtgt = oldtgt;
       for (int i = 0; i < size; i++) {
           Xagone xg = (Xagone)xs.elementAt(i);
           if ((xg.getID()==0)||(xg.getID()==id)||(xg.getBase()<cfg.nbBuild)||(xg.getAlt()<0)||inAlliance(xg.getID())) continue;
           Xagone gunner = xg.getGunner(id);
           if (gunner==null||gunner.getNb()<pwr) continue;
           if ((maxgun==null)||(maxtgt.getNb()>xg.getNb())) {
              maxgun = gunner;
              maxtgt = xg;
           }
       }
       if (maxgun!=null) {
          if ((oldgun!=null)&&(oldgun.getID()==id)&&(!inAlliance(oldtgt.getID()))&&(oldtgt.getBase()==cfg.nbBuild)&&(maxtgt.getNb()>oldtgt.getNb()/2)) {
              maxgun = oldgun;
              maxtgt = oldtgt;
          }
          map.setTarget(maxtgt,id);
          if ((maxtgt.getBase()<cfg.nbBuild)||(maxtgt.getNb()>2*pwr)) maxgun.doKey('g',id);
          else maxgun.doKey('p',id);
          oldgun = maxgun;
          oldtgt = maxtgt;
          if (prio==0) {
             prio=6;
             cntprio=5+(int)(Math.random()*10);
          }
          return;
       } else prio = 0;
    }
  }
}
