package hexamap;

import java.awt.*;
import java.rmi.*;

public class DefaultMapPainter {

  public static void paintMap(RemoteMap map,Config cfg,Graphics g,int ox,int oy,int id) throws RemoteException {
    XaStatus[][] cpy = map.copy(id);
    int l2 = cfg.size/2;
    int dx = (int)(Math.sqrt(3.0)*l2);
    for (int i = 0; i < cpy.length; i++) {
        int y = oy+i*(cfg.size+l2);
        for (int j = 0; j < cpy[i].length; j++) {
            paintHexagone(map,cfg,cpy[i][j],j,i,g,ox+j*dx*2+dx*(i%2),y,id);
        }
    }
  }

  protected static void paintHexagone(RemoteMap map,Config cfg,XaStatus cpy,int i,int j,Graphics g, int x, int y,int id) throws RemoteException {
    if (cpy.poly==null) {
       int l2 = cfg.size/2;
       int dx = (int)(Math.sqrt(3.0)*l2);
       int[] xp = new int[] {x,x+dx,x+dx,x,x-dx,x-dx};
       int[] yp = new int[] {y-cfg.size,y-l2,y+l2,y+cfg.size,y+l2,y-l2};
       cpy.poly = new Polygon(xp,yp,6);
       cpy.location = new Point(x,y);
       map.setGData(i,j,cpy.poly,cpy.location);
    }
    if (!cpy.visible) {
       g.setColor(Color.black);
       g.fillPolygon(cpy.poly);
       return;
    }
    if (cpy.alt==-cfg.nbFill) g.setColor(Color.cyan);
    else g.setColor(cpy.color);
    g.fillPolygon(cpy.poly);
    g.setColor(Color.black);
    g.drawPolygon(cpy.poly);
    int dx = (int)(Math.sqrt(3.0)*cfg.size/2)-4;
    if (cpy.alt<0&&cpy.alt>-cfg.nbFill) {
       g.setColor(Color.cyan);
       int r = (dx*(-cpy.alt)*2)/cfg.nbFill;
       g.fillOval(cpy.location.x-r/2,cpy.location.y-r/2,r+1,r+1);
    }
    if (cpy.current) {
       g.setColor(Color.orange);
       g.drawLine(cpy.poly.xpoints[0],cpy.poly.ypoints[0],cpy.poly.xpoints[3],cpy.poly.ypoints[3]);
       g.drawLine(cpy.poly.xpoints[1],cpy.poly.ypoints[1],cpy.poly.xpoints[4],cpy.poly.ypoints[4]);
       g.drawLine(cpy.poly.xpoints[2],cpy.poly.ypoints[2],cpy.poly.xpoints[5],cpy.poly.ypoints[5]);
    }
    if (cpy.base>0) {
       g.setColor(Color.black);
       g.drawArc(cpy.location.x-dx-1,cpy.location.y-dx-1,dx*2+3,dx*2+3,0,(360*cpy.base)/cfg.nbBuild);
    }
    if (cpy.id>0) {
       Color brighter = Xagone.cols[cpy.id].brighter();
       Color darker = Xagone.cols[cpy.id].darker();
       for (int k=0;k<6;k++) {
           if (cpy.goLoc[k]!=null) {
              g.setColor(Xagone.cols[cpy.id]);
              g.drawLine(x,y,(x+cpy.goLoc[k].x)/2,(y+cpy.goLoc[k].y)/2);
              g.setColor(darker);
              g.drawLine(x+1,y+1,(x+cpy.goLoc[k].x)/2-1,(y+cpy.goLoc[k].y)/2+1);
              g.setColor(brighter);
              g.drawLine(x+1,y-1,(x+cpy.goLoc[k].x)/2-1,(y+cpy.goLoc[k].y)/2-1);
           }
       }
       g.setColor(Xagone.cols[cpy.id]);
       int r = (dx*Math.max(1,cpy.nb)*2)/cfg.maxNb;
       g.fillOval(cpy.location.x-r/2,cpy.location.y-r/2,r+1,r+1);
    }
    for (int k=0;k<cpy.guns.length;k++) {
        int r = cfg.size/2;
        g.setColor(Xagone.cols[cpy.guns[k]]);
        g.fillOval(cpy.location.x+3-((int)(Math.random()*6))-r/2,cpy.location.y+3-((int)(Math.random()*6))-r/2,r,r);
    }
    for (int k=0;k<cpy.paras.length;k++) {
        int r = (int)(cfg.size/1.5);
        g.setColor(Xagone.cols[cpy.paras[k]]);
        int px = cpy.location.x+3-((int)(Math.random()*6))-r/2;
        int py = cpy.location.y+3-((int)(Math.random()*6))-r/2;
        g.fillArc(px,py,r,r,0,180);
        g.fillOval(px+r/4,py+r/2+2,r/2,r/2);
        g.drawLine(px+1,py+r/2,px+r/2,py+3*r/4);
        g.drawLine(px+r-3,py+r/2,px+r/2,py+3*r/4);
    }
  }
}
