package hexamap;

import java.awt.*;
import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

public class HexaMap extends UnicastRemoteObject {

  private Vector hy;
  private int width,height;

  public HexaMap(int width,int height) throws RemoteException {
    this.width = width;
    this.height = height;
    hy = new Vector(height);
    for (int i = 0; i < height; i++) {
        Vector hx = new Vector(width-(i%2));
        for (int j = 0; j < width-(i%2); j++) hx.addElement(createHexagone(j,i));
        hy.addElement(hx);
    }
    for (int i = 0; i < height; i++)
        for (int j = 0; j < width-(i%2); j++) getHexagone(j,i).initialize();
  }

  public Hexagone getHexagone(int i, int j) {
    if (i<0||i>=width||j<0||j>=height) return null;
    if ((j%2>0)&&(i>=width-1)) return null;
    return (Hexagone)((Vector)hy.elementAt(j)).elementAt(i);
  }

  public Hexagone hexagoneAt(int x, int y) {
    for (int i = 0; i < height; i++)
        for (int j = 0; j < width-(i%2); j++) {
            Hexagone h = getHexagone(j,i);
            if (h.contains(x,y)) return h;
        }
    return null;
  }

  public int getWidth() throws RemoteException {
    return width;
  }

  public int getHeight() throws RemoteException {
    return height;
  }

  protected Hexagone createHexagone(int mi, int mj) {
    return new Hexagone(this,mi,mj);
  }
}

