package hexamap;

import java.io.*;
import java.awt.*;
import java.rmi.*;

public class Hexagone {

  protected HexaMap map;
  private Hexagone nw,ne,e,se,sw,w;
  private Polygon poly;
  private Point location;
  private Point mapLoc;
  private Color color;

  public Hexagone(HexaMap map,int mi,int mj) {
    this.map = map;
    this.mapLoc = new Point(mi,mj);
    this.color = Color.green;
  }

  public void initialize() {
    e  = map.getHexagone(mapLoc.x+1,mapLoc.y);
    w  = map.getHexagone(mapLoc.x-1,mapLoc.y);
    if (mapLoc.y%2==0) {
       nw = map.getHexagone(mapLoc.x-1,mapLoc.y-1);
       sw = map.getHexagone(mapLoc.x-1,mapLoc.y+1);
       ne = map.getHexagone(mapLoc.x,mapLoc.y-1);
       se = map.getHexagone(mapLoc.x,mapLoc.y+1);
    } else {
       nw = map.getHexagone(mapLoc.x,mapLoc.y-1);
       sw = map.getHexagone(mapLoc.x,mapLoc.y+1);
       ne = map.getHexagone(mapLoc.x+1,mapLoc.y-1);
       se = map.getHexagone(mapLoc.x+1,mapLoc.y+1);
    }
  }

  public void setColor(Color color) {
    this.color = color;
  }

  public Color getColor() {
    return color;
  }

  public Hexagone getNW() { return nw; }

  public Hexagone getNE() { return ne; }

  public Hexagone getE()  { return e; }

  public Hexagone getSE() { return se; }

  public Hexagone getSW() { return sw; }

  public Hexagone getW()  { return w; }

  public void setGData(Polygon poly,Point location) {
    this.poly = poly;
    this.location = location;
  }

  public Point getMapLocation() {
    return mapLoc;
  }

  public Polygon getPolygon() {
    return poly;
  }

  public Hexagone[] getAll() { return new Hexagone[] {e,ne,nw,w,sw,se}; }

  public java.awt.Point getLocation() {
    return location;
  }

  public boolean contains(int x,int y) {
    return poly == null ? false : poly.contains(x,y);
  }
}

